#! /usr/bin/perl

#
# Apre il file di log e quello delle passwd. Termina il programma in 
# caso di errore
#
(open(OUT,$ARGV[0]) && open(PASSWD,$ARGV[1])) || die "File inesistenti o parametri mancanti";

#
# Scansione del file di log
#
while (<OUT>) {
 
 #
 # Questa espressione regolare cerca le linee con all'interno 
 # 'auth....failure'. Pone in $1 il giorno, e in $2 il nome dell'utente
 # che ha fallito il login.
 # Si ricordi che \d{a,b} corrisponde a cercare da 'a' a 'b' occorrenze
 # di \d
 #
 # ESEMPIO: [0-9]{3-5} = cerca una sequenza di cifre lunga dai 3 ai 5 
 # caratteri
 #
 if ( /(\w\w\w\s+\d{1,2}).*authentication failure.*user=(\w+)$/ )
 {
    $giorno = $1;
    $nome   = $2;
    #
    #  Il programma funziona nell'assunzione che il file di log
    #  Sia ordinato per giorni consecutivi.
    #
    #  Se $last{$nome} vale $giorno, c' stato un accesso fallito 
    #  nello stesso giorno.
    #
    #  Si ricordi che una variabile non inizializzata vale 'undef'.
    #
    #  Undef:
    # 
    #  se usato aritmeticamente  pari a 0,
    #  se usato in espressione booleana = false
    #  se usato come stringa = ''.
    # 
    #  dunque $darimuovere{$nome}++
    #  pone $darimuovere{$nome} = 1, nel caso questa chiave dell'array
    #  associativo non sia mai stata usata prima.
    #
    if ($last{$nome} eq $giorno)
    {  
      $darimuovere{$nome}++;  
    }
    else
    {
      $last{$nome} = $giorno;
    }
 }
}

#
# A questo punto, nell'hash %darimuovere ci sono i nomi utente da 
# rimuovere
# 

#
# Leggo tutto 'passwd' e lo chiudo.
#
@passwd = <PASSWD>;
close(PASSWD);

#
# Lo riapro in modalit scrittura. Lo riscrivo in input, omettendo
# le righe corrispondenti a utenti da rimuovere.
#
open(PASSWD,">$ARGV[1]");
open(DISABLED,">>disabled.txt");


  foreach ( @passwd )
  {
      #
      # Questa espressione mette il nome utente letto da passwd in $1
      # Se questo  presente in %darimuovere, allora aggiorno la linea.
      # Inoltre scrivo su DISABLED il nome utente e la vecchia shell.
      #
      if (/^(\w+)(:.*:)(.*)$/ && $darimuovere{$1} ) 
      {
         $userid = $1;
         $shell = $3;
         print DISABLED "$userid:$shell\n";
         print PASSWD "$1$2/bin/alert.sh\n";
      }
      #
      # Altrimenti stampo $_ invariato.
      #
      else 
      {
 	 print PASSWD $_;
      }    
  }      	

#
# Chiusure finali.
#
close PASSWD;
close DISABLED;
