#! /usr/bin/perl

#
# Apertura dei file richiesti. Esce in caso di errore.
#
open(DISABLED,"$ARGV[1]") && open(PASSWD,"$ARGV[2]") || die "Parametri mancanti o file non trovati";

#
# Legge tutto passwd in un colpo. Sarebbe possibile aggiornare passwd
# senza leggerlo tutto in memoria, ma preferiamo questa soluzione.
#
@passwd = <PASSWD>;
close PASSWD;

#
# riapre passwd in scrittura per l'aggiornamento.
#
open(PASSWD,">$ARGV[2]");

foreach ( @passwd )
{
    #
    # Questo if scatta se $3 corrisponde allo userid numerico 
    # trovato nella linea corrente.
    #
    if (/^(\w+)(:\w*:)(\d+)(:.*:)(.*)$/ && $3 eq $ARGV[0] )
    {
        #
	# Assegno $1,$2,$3 e $4 alle corrispondenti variabili
	# Si noti che $5 rappresenta il valore della shell
        # che non  necessario salvare.
	#
        $username = $1;
        $altro = $2;
        $userid = $3;
        $altro2 = $4;
        #
	# In questo ciclo cerco $username dentro DISABLED
	# Si noti che NON posso usare $_,  usato nel ciclo esterno
	#
	while ($line = <DISABLED>) {
	#
	# Blocco il ciclo se trovo una linea che comincia per
	# $username. Assegno $2 a $oldshell
	# Si noti che 'last' serve a uscire immediatamente da un ciclo
	# (equivale a 'break' del C++.  
	#
 	    last if ($line =~ /^$username:(.*)$/ && 
		     ($oldshell = $2));
        }
        #
	# Errore se $username non risulta = $1
	# 
        ( $username eq $1 ) || die "$username non presente in $ARGV[1]\n";
	#
	# stampa su passwd la riga rimettendo $oldshell come valore finale
	#
        print PASSWD "$username$altro$userid$altro2$oldshell\n"; 
    }
    #
    # Questa riga non contiene lo user id numerico cercato, la stampo invariata
    #
    else { print PASSWD $_ };	
} 
close PASSWD;
close DISABLED;

#
# Se $oldshell  nullo, vuol dire che non  stato trovato in disabled.txt
# l'utente corrispondente.
#
$oldshell || die "User ID $ARGV[0] non presente in $ARGV[2]";

#
# Come ultima operazione, rimuovo l'utente cercato da disabled.txt
# (ora  riabilitato) 
#
open(DISABLED,"$ARGV[1]");
@disabled = <DISABLED>;
close DISABLED;

open(DISABLED,">$ARGV[1]");

foreach (@disabled)
{
    print (DISABLED,$_) unless (/^$username/); 
}

close DISABLED;

